#define rxpin 3 // RX pin on ATtiny412
#define txpin 2 // TX pin on ATtiny412
#define settle 100 // Time for voltage to settle
#define samples 100 // How many samples of analogRead it takes in given time

void setup() {
  pinMode(txpin, OUTPUT); // Initializing the TX pin as OUTPUT (for sending signals through TX and recieving and measuring those same signals and their strengths through RX)
  pinMode(0, OUTPUT); // Initializing LED pin for indication
}

void loop() { // Main function looping through the other various functions
 
  //Uncomment one function depending on which test you want to run.
   instantCheck();
   //analogLED();
}

long int average() { // Function to find the average change in signal
  long int up, down, avg; 
   avg = 0; // Initializing avg as 0
   noInterrupts(); // Disables all other activities
   for (int i = 0; i < samples; i++) { // For loop which loops (samples) times
      digitalWrite(txpin, HIGH); // Sends signal through TX pin
      up = analogRead(rxpin); // Recieves signal through RX pin
      delayMicroseconds(settle); // Delays for 100 microseconds so that signal can level out
      digitalWrite(txpin, LOW); // Takes away signal from TX
      down = analogRead(rxpin); // Reads RX pin after removing signal
      delayMicroseconds(settle); // Delays again so that signal can level out
      avg += up - down; // Measuring capacitance of system as in theory avg should be 0 if copper plates were connected
   }
   interrupts(); // Allows other activites to occur again
   return avg; // Returns the avg value
}

void instantCheck() { // Function to simply check functionality of the program
  long int avg = average(); // Takes one sample of average() function
  if (avg > 3000) { // If capacitance over 
    digitalWrite(0, LOW); 
    digitalWrite(rxpin, HIGH); // Turns LED on if avg is greater than 9000 (exterior influence was high)
  }
  else {
    digitalWrite(0, HIGH); 
    digitalWrite(rxpin, LOW);
  }
}



